program TreeTester;
  { To illustrate use of unit TreeViewer; requires TPointSet.MakeNodeBT }
  { Tom Verhoeff (TUE, 2007) }

uses
  Vectors in 'Vectors.pas',
  PointSets in 'PointSets.pas',
  TreeViewer in 'TreeViewer.pas';

var
  t: PNode; // the "tree" under test

begin
  t := nil;
  WriteTree('TreeTester: nil', 't', t);

  t := MakeNodeBT(TVector.Create(7, 0),
        MakeNodeBT(TVector.Create(3, 0),
           MakeNodeBT(TVector.Create(2, 0), nil, nil),
           MakeNodeBT(TVector.Create(5, 0), nil, nil)),
         MakeNodeBT(TVector.Create(11, 0), nil, nil));
  WriteTree('TreeTester: valid TBinTree', 't', t);

  t^.FLeft^.FLeft^.FLeft := t; // create a cycle, violating I0
  WriteTree('TreeTester: cycle', 't', t);

  t^.FLeft^.FLeft^.FLeft := nil; // restore I0
  t^.FRight^.FLeft := t^.FLeft^.FRight; // converging root paths, violating I1
  WriteTree('TreeTester: converging root paths', 't', t);

  t^.FRight^.FLeft := nil; // restore I1

  // t is a valid TBinTree again
  t := MakeNodeBT(TVector.Create(0, 0), t, nil); // order violated
  WriteTree('TreeTester: order violated', 't', t);

  // if DisposeBT is implemented you can uncomment the next line
  // DisposeBT(t); // to avoid a (harmless) memory leak
end.
